#' Read FLEXPART particle dump
#'
#' Reads FLEXPART model output in the form of directly dumped particle information. Typical 
#' file names are partposit_end, partposit_<output time>, and partposit_inst. The latter is
#' generated by FLEXPART-COSMO for terminated particles. Termination happens either when a 
#' particle leaves the domain or when it reaches its maximum age (AGECLASSES). Slightly different
#' output formats exist between FLEXPART and FLEXPART-COSMO and for partposit_inst files. The
#' function should catch these differences and return meaningful column names (see below). 
#'
#' @param fn file to read from should be FLEXPART output in files partposit_end or partposit_inst
#' @param hdr FLEXPART header information as returned by read.header. If missing function 
#' 		will try to locate header file an read it again.
#' @param maxn maximal number of particles to read. Default is 3E6 if information cannot be taken
#'		from header information. Set to larger value if file
#'		contains more particles. 
#' @param is.cosmo (logical) If TRUE FLEXPART-COSMO output is assumed, even if hdr suggests 
#'		something else. If missing is.cosmo is taken from hdr. 
#'
#' @return data.frame with the columns
#' npoint: number of release location
#' x:            x position of particle (E)
#' y:            y position of particle (N)
#' z:             z position of particle (m above model ground)
#' itramem: time when particle was released (in seconds since model start)
#' oro:        height of topography below particle
#' zlev:       this should be the vertical level index in particle dump files ending with time stamp or _end 
#' itime:      for partposit_inst files zlev is overwritten with the time when the particle was terminated (either because it left the domain or because it reached its maximal age). Again this time is given in seconds since model start.
#' pv:          PV at particle position (not in *_inst files)
#' qq:         specific humidity at particle position
#' rho:        density at particle position
#' tropo:   tropopause height at particle position
#' tt:           temperature 
#' mass_<species name>  mass of particle 
#'
#' @export
read.particle.dump = function(fn, hdr, nspec=1, maxn=NULL, is.cosmo, is.ctm, 
	nn.reals){

	if (missing(fn)) fn = file.choose()

	if (!file.exists(fn)) {
		warning("File not found.")
		return(NULL)
	}

    is.zip = (regexpr(".gz", fn)>0)

	if (missing(hdr)){
		hdr = read.header(file.path(dirname(fn), "header"))
	}

	if (is.null(hdr)){
		warning("No header information found.")
		return(NULL)
	}

	if (is.null(maxn)){
		maxn = sum(hdr$rel.npart, na.rm=TRUE)
		if (length(maxn)==0){
			maxn = 3E6
		}
		if (is.na(maxn)){
			maxn = 3E6
		}
	}

	if (missing(is.cosmo)){
		is.cosmo = hdr$is.cosmo
	}

	if (missing(is.ctm)){
		is.ctm = grepl("CTM", hdr$model)
	}

	if (is.cosmo){
		is.inst = (regexpr("_inst$", fn)>0 || regexpr("_inst.gz$", fn)>0)
	}

	if (is.zip){
        strm = gzfile(fn, open="rb")
	} else {
		strm = file(fn, open="rb")
	}
	
#	seek(strm, 4, "current")
    dummy = readBin(strm, "raw", n=4)

	#	itime
	itime = readBin(strm, "integer", n=1, size=4)
	cat("itime:", itime, "\n")

	if (!is.cosmo && is.ctm){
		nspec = readBin(strm, "integer", n=1, size=4)
		nclock = readBin(strm, "integer", n=1, size=4)
		cat("nspec:", nspec, "nclock:", nclock, "\n")
	}
	
	if (missing(nn.reals)){
		if (is.cosmo){
			if (is.inst){
				nn.reals = 7
			} else {
				nn.reals = 8
			}
		} else{	
			nn.reals = 7
		}
	}

	aa = matrix(NA, nrow=maxn, ncol=5+nn.reals+hdr$nspec)
	idx = 1

	#	main loop over all particles
	repeat{
#	 	seek(strm, 8, "current")
	    dummy = readBin(strm, "raw", n=8)
		
		npoint = readBin(strm, "integer", n=1, size=4)
		if (length(npoint)==0) break
		if (npoint<0) break
		if (idx>maxn) break

		aa[idx, ] = c(npoint,readBin(strm, "numeric", n=3, size=4), 
			readBin(strm, "integer", n=1, size=4), 
			readBin(strm, "numeric", n=nn.reals+hdr$nspec, size=4))

		idx = idx + 1
	}	#	end of loop over particles
	close(strm)


	if (idx < 2) {
		warning(fn, "does not contain valid particle dump. Returning NULL.")
		return(NULL)
	}

	aa = aa[1:(idx-1),]	
	dim(aa) = c(idx-1, nn.reals+hdr$nspec+5)
	if (is.cosmo){
		if (is.inst){
			tmp = c("npoint", "x", "y", "z", "itramem", "oro", "itime", "qq", "rho", 
				"hmix", "tropo", "tt")
			if (nn.reals>7) tmp = c(tmp, paste0("X.", 1:(nn.reals-7)))
		} else {
			tmp = c("npoint", "x", "y", "z", "itramem", "oro", "zlev", "pv", "qq", "rho", 
				"hmix", "tropo", "tt")
			if (nn.reals>8) tmp = c(tmp, paste0("X.", 1:(nn.reals-8)))
		}
	} else {
		tmp = c("npoint", "x", "y", "z", "itramem", "oro", "pv", "qq", "rho", 
			"hmix", "tropo", "tt")
		if (nn.reals>7) tmp = c(tmp, paste0("X.", 1:(nn.reals-7)))
	}

	tmp = c(tmp, paste("mass_", 1:hdr$nspec, sep=""))
	colnames(aa) = tmp
	aa = as.data.frame(aa)	

	attr(aa, "itime") = itime
	return(aa)
}

#library(Rflexpart)
#particle.file <- "/remote2/brd134/FLEXPART_COSMO/LAE/2014/2014010100/partposit_inst.gz"
#test <- read.particle.dump(particle.file, maxn=10)

